# NOTE: Derived from blib/lib/Puppet/Show.pm.
# Changes made here will be lost when autosplit again.
# See AutoSplit.pm.
package Puppet::Show;

#line 368 "blib/lib/Puppet/Show.pm (autosplit into blib/lib/auto/Puppet/Show/display.al)"
sub display
  {
    my $self =shift ;
    my %args = @_;

    my $master = $args{master}; # master destroyed -> exit ;
    my $onDestroy = $args{onDestroy} ; # sub ref to perform cleanup;

    if (defined $self->{multitop})
      {
        $self->{multitop}->deiconify() 
          if ($self->{multitop}->state() eq 'iconic') ;
	$self->{multitop}->raise();
	return undef ;
      }
    
    my $type = ref($self) ;
    $type =~ s/^.*::// ;
    my $labelName = ref($self->cloth).': ';
    if (defined $self->{title}) {$labelName .= $self->{title};} 
    else {$labelName .= $self->{'name'} ;} 
    
    $self->printDebug("Creating Multitop display for ".ref($self)."\n") ;

    my $poof ;
    my $top = $self->{multitop} = $self->{topTk} -> MultiTop
      (
       podName => $self->{podName},
       podSection => $self->{podSection},
       manager => $self->cloth
      );

    my $dsub ;
    if (defined $master and $master) 
      {
        $dsub = sub
          {
            &$onDestroy if defined $onDestroy ;
            $self->{topTk}->destroy;
          } ;
      }
    else 
      {
        $dsub = sub
          {
            &$onDestroy if defined $onDestroy ;
            delete $self->{multitop};
          };
      }

    $self->{multitop} -> OnDestroy($dsub); 

    $self->{multitop} -> title($labelName) ;

    # config debug window
    foreach (qw(debug event))
      {
        $self->{'log'}{$_} -> display ($self->{multitop},1);
      }
   
    foreach my $what (qw/container content/)
      {
        next unless defined $self->{$what} ;

        foreach my $name (sort keys %{$self->{$what}})
          {
            my $ref = $self->{$what}{$name};
            my $sub = ref($self->{raise}) eq 'CODE' ? $self->{raise} :
              sub{$ref->cloth->display(); } ;
            $self->{multitop}->menuCommand
              ( 
               name => $name,
               menu => $what,
               command => $sub
              ) ;
          }
      }

    return $self->{multitop} ;
  }

# end of Puppet::Show::display
1;
